import * as bb from 'barbary';
export declare class PathComponent {
    name: string;
    displayName: string;
    constructor(name: string, displayName: string);
}
export declare class PathBarItem {
    static fromPathComponent(comp: PathComponent): PathBarItem;
    urlName: string;
    htmlDisplayName: string;
    fullURL: string;
    constructor(name: string, displayName: string);
    updateParentURL(parentURL: string | null): void;
}
export declare class Processor {
    srcDir: string;
    destDir: string;
    logger: bb.Logger;
    ignoredFiles: {
        [key: string]: boolean | null;
    };
    constructor(srcDir: string, destDir: string, logger: bb.Logger);
    startFromFile(relFile: string): Promise<void>;
    private processDir(relDir, stackCount);
    private isRootDir(dir);
    private makeSrcPath(relFile);
    private makeDestPath(relFile);
    private markdownToHTML(relFile);
    private pathComponentFromDir(dir);
    private pathComponentFromFile(file);
    private generatePathBarHtml(comps);
    private childComponentsFromDirs(dirs);
    private childComponentsFromFiles(files);
    private generateContentHtml(comps);
    private isLeafDir(absDir);
    private writeTitleFileForFile(relFile, title);
    private writeTitleFileForDir(relDir, title);
}
