"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var nodepath = require("path");
var mfs = require("./mfs");
var titleExtractor_1 = require("./titleExtractor");
var escapeHTML = require('escape-html');
var ROOTPROJ = 'root.json';
var PATHBAR_HTML = 'pathBar.g.html';
var CONTENT_HTML = 'content.g.html';
var dirCache = {};
var PathComponent = (function () {
    function PathComponent(name, displayName) {
        this.name = name;
        this.displayName = displayName;
    }
    return PathComponent;
}());
exports.PathComponent = PathComponent;
var HTMLGen = (function () {
    function HTMLGen() {
    }
    HTMLGen.aRaw = function (nameHtml, hrefUrl) {
        return "<a href=\"" + hrefUrl + "\">" + nameHtml + "</a>";
    };
    HTMLGen.a = function (name, href) {
        return this.aRaw(escapeHTML(name), encodeURIComponent(href));
    };
    HTMLGen.aFromComp = function (comp) {
        return this.a(comp.name, comp.displayName);
    };
    return HTMLGen;
}());
var DirComponentGenerator = (function () {
    function DirComponentGenerator(srcDir, destDir) {
        this.srcDir = srcDir;
        this.destDir = destDir;
    }
    DirComponentGenerator.prototype.startFromFile = function (file) {
        return __awaiter(this, void 0, void 0, function () {
            var dir, components;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        dir = nodepath.dirname(file);
                        return [4, this.pathComponentsFromDir(dir)];
                    case 1:
                        components = _a.sent();
                        return [2];
                }
            });
        });
    };
    DirComponentGenerator.prototype.processDir = function (dir) {
        return __awaiter(this, void 0, void 0, function () {
            var dirComponent, reversedComponents, parentDir, parents, _i, parents_1, p, relDir, destPathBarHtml, pathBarHtml, subPaths, isFile, childComponents, contentHtml, contentPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (dirCache[dir]) {
                            return [2, dirCache[dir]];
                        }
                        return [4, this.pathComponentFromDir(dir)];
                    case 1:
                        dirComponent = _a.sent();
                        reversedComponents = [dirComponent];
                        return [4, this.isRootDir(dir)];
                    case 2:
                        if (!((_a.sent()) === false)) return [3, 4];
                        parentDir = nodepath.dirname(dir);
                        return [4, this.processDir(parentDir)];
                    case 3:
                        parents = _a.sent();
                        for (_i = 0, parents_1 = parents; _i < parents_1.length; _i++) {
                            p = parents_1[_i];
                            reversedComponents.push(p);
                        }
                        _a.label = 4;
                    case 4:
                        relDir = nodepath.relative(this.srcDir, dir);
                        destPathBarHtml = nodepath.join(this.destDir, relDir, PATHBAR_HTML);
                        pathBarHtml = this.headerHtmlFromDirComponents(reversedComponents.slice().reverse());
                        return [4, mfs.writeFileAsync(destPathBarHtml, pathBarHtml)];
                    case 5:
                        _a.sent();
                        return [4, mfs.listSubPaths(dir)];
                    case 6:
                        subPaths = _a.sent();
                        if (!subPaths.length) {
                            throw new Error("No subPaths found in directory \"" + dir + "\"");
                        }
                        return [4, mfs.fileExists(subPaths[0])];
                    case 7:
                        isFile = _a.sent();
                        if (!isFile) return [3, 9];
                        return [4, this.childComponentsFromDirs(subPaths)];
                    case 8:
                        childComponents = _a.sent();
                        return [3, 11];
                    case 9: return [4, this.childComponentsFromFiles(subPaths)];
                    case 10:
                        childComponents = _a.sent();
                        _a.label = 11;
                    case 11:
                        contentHtml = this.generateContentHtml(childComponents);
                        contentPath = nodepath.join(this.destDir, relDir, CONTENT_HTML);
                        return [4, mfs.writeFileAsync(contentPath, contentHtml)];
                    case 12:
                        _a.sent();
                        dirCache[dir] = reversedComponents;
                        return [2, reversedComponents];
                }
            });
        });
    };
    DirComponentGenerator.prototype.isRootDir = function (dir) {
        return __awaiter(this, void 0, void 0, function () {
            var rootFile;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        rootFile = nodepath.join(dir, ROOTPROJ);
                        return [4, mfs.fileExists(rootFile)];
                    case 1: return [2, _a.sent()];
                }
            });
        });
    };
    DirComponentGenerator.prototype.pathComponentFromDir = function (dir) {
        return __awaiter(this, void 0, void 0, function () {
            var dirName, title;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        dirName = nodepath.basename(dir);
                        return [4, titleExtractor_1.default.fromDir(dir)];
                    case 1:
                        title = _a.sent();
                        return [2, new PathComponent(dirName, title)];
                }
            });
        });
    };
    DirComponentGenerator.prototype.pathComponentFromFile = function (file) {
        return __awaiter(this, void 0, void 0, function () {
            var name, title;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        name = nodepath.parse(file).name;
                        return [4, titleExtractor_1.default.fromFile(file)];
                    case 1:
                        title = _a.sent();
                        return [2, new PathComponent(name, title)];
                }
            });
        });
    };
    DirComponentGenerator.prototype.generatePathBarHtml = function (comps) {
        var res = '';
        for (var _i = 0, comps_1 = comps; _i < comps_1.length; _i++) {
            var comp = comps_1[_i];
            var aHtml = HTMLGen.a(comp.displayName, comp.name);
            res += aHtml;
        }
        return '';
    };
    DirComponentGenerator.prototype.childComponentsFromDirs = function (dirs) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, Promise.all(dirs.map(function (d) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4, this.pathComponentFromDir(d)];
                                    case 1: return [2, _a.sent()];
                                }
                            });
                        }); }))];
                    case 1: return [2, _a.sent()];
                }
            });
        });
    };
    DirComponentGenerator.prototype.childComponentsFromFiles = function (files) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4, Promise.all(files.map(function (file) { return __awaiter(_this, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4, this.pathComponentFromFile(file)];
                                    case 1: return [2, _a.sent()];
                                }
                            });
                        }); }))];
                    case 1: return [2, _a.sent()];
                }
            });
        });
    };
    DirComponentGenerator.prototype.generateContentHtml = function (comps) {
        var res = '<ul>';
        for (var _i = 0, comps_2 = comps; _i < comps_2.length; _i++) {
            var comp = comps_2[_i];
            var aHtml = HTMLGen.aFromComp(comp);
            res += "<li>" + aHtml + "</li>";
        }
        res += '</ul>';
        return res;
    };
    return DirComponentGenerator;
}());
exports.default = DirComponentGenerator;
//# sourceMappingURL=genHC.js.map