"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const mfs = require("m-fs");
const nodepath = require("path");
const DIR_TITLE_FILE = 't.txt';
class TitleExtractor {
    static get TITLE_FILE() {
        return DIR_TITLE_FILE;
    }
    static fromFile(file) {
        return __awaiter(this, void 0, void 0, function* () {
            const content = yield mfs.readTextFileAsync(file);
            return this.fromFileContent(content, file);
        });
    }
    static fromFileContent(content, logFile) {
        const firstLine = content.split('\n').shift();
        if (!firstLine) {
            throw new Error(`Cannot find a valid title in file: "${logFile}"`);
        }
        let title = firstLine;
        title = title.substr(1);
        return title.trim();
    }
    static fromDir(dir) {
        return __awaiter(this, void 0, void 0, function* () {
            const tTxt = nodepath.join(dir, DIR_TITLE_FILE);
            let displayTitle = '';
            if (yield mfs.fileExists(tTxt)) {
                displayTitle = yield mfs.readFileAsync(tTxt, 'utf8');
            }
            else {
                displayTitle = nodepath.basename(dir);
            }
            return displayTitle;
        });
    }
}
exports.default = TitleExtractor;
//# sourceMappingURL=titleExtractor.js.map